﻿'Rubashka Vasiliy
'Ukraine
'2011

Imports System.Math
Imports System.Drawing
Imports System.Drawing.Imaging
Imports Un4seen.Bass
Imports System.Diagnostics
Imports System.Management
Imports System.Xml
Imports System.IO
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Text.RegularExpressions
Imports Many_ru
Imports Many_uk
Imports Prognoz

<Runtime.InteropServices.StructLayout(Runtime.InteropServices.LayoutKind.Sequential, CharSet:=Runtime.InteropServices.CharSet.Auto)> _
Public Structure WAVEOUTCAPS
    Public wMid As Short
    Public wPid As Short
    Public vDriverVersion As Integer

    <System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=32)> _
    Public szPname As String
    Public dwFormats As Integer
    Public wChannels As Short
    Public wReserved As Short
    Public dwSupport As Integer
End Structure

Module InpOut32_Declarations
    'Inp and Out declarations for port I/O using inpout32.dll.
    Public Declare Function Inp Lib "inpout32.dll" Alias "Inp32" (ByVal PortAddress As Short) As Short
    Public Declare Sub Out Lib "inpout32.dll" Alias "Out32" (ByVal PortAddress As Short, ByVal Value As Short)
End Module

Module Winmm_Declarations
    Public Declare Function waveOutGetNumDevs Lib "winmm.dll" () As Integer
    Declare Auto Function waveOutGetDevCaps Lib "winmm.dll" (ByVal uDeviceID As Integer, ByRef lpCaps As WAVEOUTCAPS, ByVal uSize As Integer) As Integer
    Declare Function mixerClose Lib "winmm.dll" (ByVal hmx As IntPtr) As Integer
End Module

Public Class Form_gadjet

#Region "Declarations"
    Dim MyClass_manyRU As New Many_ru.Class_many
    Dim MyClass_manyUK As New Many_uk.Class_many
    Dim MyClass_prognoz As New Prognoz.Class_prognoz

    Const xc = 15 'начало по X
    Const yc = 15 'начало по Y
    Dim x(63) As Integer    'массив координат светодиодов по X
    Dim y(63) As Integer    'массив координат светодиодов по Y
    Dim col 'счётчик колонок
    Dim row 'счётчик строк
    Dim st_led 'счётчик светодиодов
    Dim random
    Dim steps = 0 'счётчик шагов 
    Dim qqq 'служебная переменная
    Dim www(0 To 772) As Boolean 'служебная переменная
    Dim ed_chas As Integer
    Dim des_chas As Integer
    Dim ed_min As Integer
    Dim des_min As Integer
    Dim ed_sek As Integer
    Dim des_sek As Integer
    Dim buf_USB(63) As Byte

    Dim vid As Integer = &HFFFF
    Dim pid As Integer = &H5555
    Dim ver As Short = -1
    Dim ind As Short = 0
    Dim Handless, res As Integer
    Dim Buffer(1) As Byte
    Dim Buffers(1) As Byte
    Dim State 'Состояние устройства HID

    Public Brush As New SolidBrush(Color.OrangeRed) 'оранжево-красная кисть
    Public Brush1 As New SolidBrush(Color.DimGray) 'темно-серая кисть

    Public g As Graphics 'System.Drawing.Graphics
    Dim ellipseRect As Rectangle 'эллипс
    Dim myPath As New Drawing2D.GraphicsPath 'регион включенных светодиодов
    Dim myPath1 As New Drawing2D.GraphicsPath 'регион выключенных светодиодов

    Private recChannel As Integer
    Private fft As Single() = New Single(4096) {}    'массив выборок фурье
    Dim zzz As Double    'общий уровень 
    Dim zzz_new As Double    'общий уровень 
    Dim D As Integer() = New Integer(7) {}
    Dim D1 As Integer() = New Integer(7) {}
    Dim D2 As Integer() = New Integer(7) {}
    Dim Dmax As Integer() = New Integer(7) {}
    Dim ccc As Integer

    Dim Xxx As Integer
    Dim Yyy As Double() = New Double(7) {}
    Dim Z As Double() = New Double(7) {}
    Dim K As Double
    Dim U As Integer() = New Integer(7) {}    'Начальные значения регуляторов уровня каналов 
    Dim master As Integer    'общий уровень 

    Dim string_len As Integer 'длина текстового сообщения
    Dim string_text As String 'текст сообщения
    Dim string_steps As Integer 'шаги для вывода текста
    Dim ddd(0 To 63) As Boolean 'массив подготовленного текста из 2 букв

    Declare Function GetPixel Lib "gdi32" Alias "GetPixel" (ByVal hdc As Integer, ByVal x As Integer, ByVal y As Integer) As Integer
    Private Declare Function ExtFloodFill Lib "gdi32" (ByVal hDC As IntPtr, ByVal X As Integer, ByVal Y As Integer, ByVal crColor As Integer, ByVal wFillType As Long) As Long
    Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As IntPtr
    Public Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As IntPtr, ByVal hGdiObj As IntPtr) As IntPtr

    Private Declare Function URLDownloadToFile Lib "urlmon" Alias "URLDownloadToFileA" (ByVal pCaller As Integer, ByVal szURL As String, ByVal szFileName As String, ByVal dwReserved As Integer, ByVal lpfnCB As Integer) As Integer
    Public Event ErrorDownload(ByVal FromPathName As String, ByVal ToPathName As String)
    Public Event DownloadComplete(ByVal FromPathName As String, ByVal ToPathName As String)
    Dim puth As String 'Путь к запущенному приложению 
    Dim sity As String 'Город для прогноза
    Dim url As String 'Файл на сервере с прогнозом погоды
    Dim Prognoz_file As String 'Файл на клиенте, куда положить прогноз погоды
    Dim Many_file As String 'Файл на клиенте, куда положить котировку валюты
    Dim Text_file As String 'Файл загружаемого текста
    Dim flg_prognoz As Boolean = False 'файл разрешения загрузки прогноза
    Dim TabControl_index As Integer 'индекс вкладки при старте
    Shared mMutex As System.Threading.Mutex

    Public Function DownloadFile(ByVal FromPathName As String, ByVal ToPathName As String, ByVal idTextbox As Integer)

        If URLDownloadToFile(0, FromPathName, ToPathName, 0, 0) = 0 Then
            DownloadFile = True
            RaiseEvent DownloadComplete(FromPathName, ToPathName)
        Else
            DownloadFile = False
            RaiseEvent ErrorDownload(FromPathName, ToPathName)
            If idTextbox = 2 Then
                TextBox2.Text = "Нет связи с метео-сервером! "
            End If
            If idTextbox = 3 Then
                TextBox3.Text = "Нет связи с НБУ! "
            End If
        End If

    End Function

    <Serializable()> _
    Public Class MyClass0
        Public TabControl As Integer
        Public TP1 As MyClass1
        Public TP2 As MyClass2
        Public TP3 As MyClass3
        Public TP4 As MyClass4
        Public TP5 As MyClass5
        Public TP6 As MyClass6
        Public TP7 As MyClass7
    End Class
    <Serializable()> _
    Public Class MyClass1
        Public TB1 As Integer
        Public TB2 As Integer
        Public TB6 As Integer
        Public RB As Integer
        Public CB2 As Boolean
        Public CB7 As Boolean
    End Class
    <Serializable()> _
    Public Class MyClass2
        Public TB3 As Integer
        Public CB1 As Boolean
        Public Clok As Integer
    End Class
    <Serializable()> _
    Public Class MyClass3
        Public TB8 As Integer
        Public RB As Integer
        Public CB9 As Boolean
        Public CB10 As Boolean
        Public Combo2 As Integer
    End Class
    <Serializable()> _
    Public Class MyClass4
        Public TB5 As Integer
        Public RB As Integer
        Public CB3 As Boolean
        Public CB6 As Boolean
        Public Combo3 As Integer
    End Class
    <Serializable()> _
    Public Class MyClass5
        Public TB7 As Integer
        Public RB As Integer
        Public CB4 As Boolean
        Public CB8 As Boolean
        Public CB11 As Boolean
        Public CB12 As Boolean
        Public CB13 As Boolean
        Public CB14 As Boolean
        Public Combo1 As Integer
    End Class
    <Serializable()> _
    Public Class MyClass6
        Public TB4 As Integer
        Public RB As Integer
        Public CB5 As Boolean
    End Class
    <Serializable()> _
    Public Class MyClass7

    End Class

#End Region

#Region "Massiv Datas"
    'Массив значений для калейдоскопа
    Private Kaleydos As Integer() = {0, 7, 56, 63, 1, 15, 48, 62, 2, 23, 40, 61, 3, 31, 32, 60, _
                                       6, 8, 55, 57, 9, 14, 49, 54, 10, 22, 41, 53, 11, 30, 33, 52, _
                                       5, 16, 47, 58, 13, 17, 46, 50, 18, 21, 42, 45, 19, 29, 34, 44, _
                                       4, 24, 39, 59, 12, 25, 38, 51, 20, 26, 37, 43, 27, 28, 35, 36}


    'массив цифр для 1 варианта часов
    Private Matrix_ As Boolean() = { _
         0, 0, 0, 0, 0, 0, 0, 0, _
         0, 0, 0, 0, 0, 0, 0, 0, _
         0, 0, 0, 0, 0, 0, 0, 0, _
         0, 0, 0, 0, 0, 0, 0, 0, _
         0, 0, 0, 0, 0, 0, 0, 0, _
         0, 0, 0, 0, 0, 0, 0, 0, _
         0, 0, 0, 0, 0, 0, 0, 0, _
         0, 0, 0, 0, 0, 0, 0, 0 _
     }
    Private Matrix_0 As Boolean() = { _
         0, 0, 1, 1, 1, 1, 0, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 1, 1, 0, 0, 1, 1, 0, _
         0, 1, 1, 0, 0, 1, 1, 0, _
         0, 1, 1, 0, 0, 1, 1, 0, _
         0, 1, 1, 0, 0, 1, 1, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 0, 1, 1, 1, 1, 0, 0 _
         }
    Private Matrix_1 As Boolean() = { _
         0, 0, 0, 1, 1, 0, 0, 0, _
         0, 0, 1, 1, 1, 0, 0, 0, _
         0, 1, 1, 1, 1, 0, 0, 0, _
         0, 0, 0, 1, 1, 0, 0, 0, _
         0, 0, 0, 1, 1, 0, 0, 0, _
         0, 0, 0, 1, 1, 0, 0, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 1, 1, 1, 1, 1, 1, 0 _
         }
    Private Matrix_2 As Boolean() = { _
         0, 0, 1, 1, 1, 1, 0, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 1, 1, 0, 0, 1, 1, 0, _
         0, 0, 0, 0, 0, 1, 1, 0, _
         0, 0, 0, 1, 1, 1, 0, 0, _
         0, 0, 1, 1, 0, 0, 0, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 1, 1, 1, 1, 1, 1, 0 _
         }
    Private Matrix_3 As Boolean() = { _
         0, 0, 1, 1, 1, 1, 0, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 1, 1, 0, 0, 1, 1, 0, _
         0, 0, 0, 0, 1, 1, 0, 0, _
         0, 0, 0, 0, 1, 1, 0, 0, _
         0, 1, 1, 0, 0, 1, 1, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 0, 1, 1, 1, 1, 0, 0 _
         }
    Private Matrix_4 As Boolean() = { _
         0, 0, 0, 0, 1, 1, 0, 0, _
         0, 0, 0, 1, 1, 1, 0, 0, _
         0, 0, 1, 1, 1, 1, 0, 0, _
         0, 1, 1, 0, 1, 1, 0, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 0, 0, 0, 1, 1, 0, 0, _
         0, 0, 0, 0, 1, 1, 0, 0 _
         }
    Private Matrix_5 As Boolean() = { _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 1, 1, 0, 0, 0, 0, 0, _
         0, 1, 1, 1, 1, 1, 0, 0, _
         0, 0, 0, 1, 1, 1, 1, 0, _
         0, 1, 1, 0, 0, 1, 1, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 0, 1, 1, 1, 1, 0, 0 _
         }
    Private Matrix_6 As Boolean() = { _
         0, 0, 1, 1, 1, 1, 0, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 1, 1, 0, 0, 1, 1, 0, _
         0, 1, 1, 1, 1, 0, 0, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 1, 1, 0, 0, 1, 1, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 0, 1, 1, 1, 1, 0, 0 _
         }
    Private Matrix_7 As Boolean() = { _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 1, 1, 0, 0, 1, 1, 0, _
         0, 0, 0, 0, 1, 1, 0, 0, _
         0, 0, 0, 1, 1, 0, 0, 0, _
         0, 0, 0, 1, 1, 0, 0, 0, _
         0, 0, 0, 1, 1, 0, 0, 0, _
         0, 0, 0, 1, 1, 0, 0, 0 _
         }
    Private Matrix_8 As Boolean() = { _
         0, 0, 1, 1, 1, 1, 0, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 1, 1, 0, 0, 1, 1, 0, _
         0, 0, 1, 1, 1, 1, 0, 0, _
         0, 0, 1, 1, 1, 1, 0, 0, _
         0, 1, 1, 0, 0, 1, 1, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 0, 1, 1, 1, 1, 0, 0 _
         }
    Private Matrix_9 As Boolean() = { _
         0, 0, 1, 1, 1, 1, 0, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 1, 1, 0, 0, 1, 1, 0, _
         0, 0, 1, 1, 1, 1, 1, 0, _
         0, 0, 0, 1, 1, 1, 1, 0, _
         0, 1, 1, 0, 0, 1, 1, 0, _
         0, 1, 1, 1, 1, 1, 1, 0, _
         0, 0, 1, 1, 1, 1, 0, 0 _
         }
    Private Matrix_dvtch As Boolean() = { _
         0, 0, 0, 0, 0, 0, 0, 0, _
         0, 0, 0, 1, 1, 0, 0, 0, _
         0, 0, 0, 1, 1, 0, 0, 0, _
         0, 0, 0, 0, 0, 0, 0, 0, _
         0, 0, 0, 0, 0, 0, 0, 0, _
         0, 0, 0, 1, 1, 0, 0, 0, _
         0, 0, 0, 1, 1, 0, 0, 0, _
         0, 0, 0, 0, 0, 0, 0, 0 _
         }
#End Region

    Public Sub New()
        '==================================================================================================
        'Проверка, чтобы приложение не запускалось дважды, выполняется при загрузке программы 
        Dim IsMutexCreatedSuccess As Boolean
        'Пытаемся создать собственный (для запущенного потока) блок взаимного исключения c именем "qwerty12345"
        mMutex = New System.Threading.Mutex(True, "qwerty12345", IsMutexCreatedSuccess)
        'Если создание не получилось, т.е. такой объект в ОС уже есть, выводим сообщение и убиваем текущий процесс
        If IsMutexCreatedSuccess = False Then
            MessageBox.Show("Приложение уже запущено!", "ОШИБКА!!!")
            System.Diagnostics.Process.GetCurrentProcess.Kill()
        Else
            'Сохраняем наш мьютекс от активности сборщика мусора
            GC.KeepAlive(mMutex)
            'Далее нормальная загрузка
            InitializeComponent()
            TabControl1.SelectedIndex = TabControl_index

        End If
    End Sub

    ''' <summary>
    ''' Действия при закрытии формы
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        NotifyIcon1.Visible = False
        'При закрытии формы закрыть девайс
        Handless = HID_OpenDevice(pid, vid, ver, ind)
        Buffers(1) = 0
        For i = 1 To 8
            res = HID_WriteDevice(Handless, Buffers, 2)
        Next
        res = HID_CloseDevice(Handless)

        'Запишем сериализацию
        Dim z0 As New MyClass0

        z0.TabControl = TabControl1.SelectedIndex
        '-----------------------------------------
        Dim w1 As New MyClass1
        w1.TB1 = TrackBar1.Value
        w1.TB2 = TrackBar2.Value
        w1.TB6 = TrackBar6.Value
        w1.CB2 = CheckBox2.Checked
        w1.CB7 = CheckBox7.Checked
        If RadioButton1.Checked = True Then
            w1.RB = 1
        End If
        If RadioButton2.Checked = True Then
            w1.RB = 2
        End If
        If RadioButton3.Checked = True Then
            w1.RB = 3
        End If
        z0.TP1 = w1
        '-----------------------------------------
        Dim w2 As New MyClass2
        w2.TB3 = TrackBar3.Value
        w2.CB1 = CheckBox1.Checked
        If Clock1.Checked = True Then
            w2.Clok = 1
        End If
        If Clock2.Checked = True Then
            w2.Clok = 2
        End If
        If Clock3.Checked = True Then
            w2.Clok = 3
        End If
        z0.TP2 = w2
        '-----------------------------------------
        Dim w3 As New MyClass3
        w3.TB8 = TrackBar8.Value
        w3.CB9 = CheckBox9.Checked
        w3.CB10 = CheckBox10.Checked
        If RadioButton12.Checked = True Then
            w3.RB = 12
        Else
            w3.RB = 11
        End If
        w3.Combo2 = ComboBox2.SelectedIndex
        z0.TP3 = w3
        '-----------------------------------------
        Dim w4 As New MyClass4
        w4.TB5 = TrackBar5.Value
        w4.CB3 = CheckBox3.Checked
        w4.CB6 = CheckBox6.Checked
        If RadioButton7.Checked = True Then
            w4.RB = 7
        Else
            w4.RB = 8
        End If
        w4.Combo3 = ComboBox3.SelectedIndex
        z0.TP4 = w4
        '-----------------------------------------
        Dim w5 As New MyClass5
        w5.TB7 = TrackBar7.Value
        w5.CB4 = CheckBox4.Checked
        w5.CB8 = CheckBox8.Checked
        w5.CB11 = CheckBox11.Checked
        w5.CB12 = CheckBox12.Checked
        w5.CB13 = CheckBox13.Checked
        w5.CB14 = CheckBox14.Checked
        If RadioButton10.Checked = True Then
            w5.RB = 10
        Else
            w5.RB = 9
        End If
        w5.Combo1 = ComboBox1.SelectedIndex
        z0.TP5 = w5
        '-----------------------------------------
        Dim w6 As New MyClass6
        w6.TB4 = TrackBar4.Value
        w6.CB5 = CheckBox5.Checked
        If RadioButton4.Checked = True Then
            w6.RB = 4
        End If
        If RadioButton5.Checked = True Then
            w6.RB = 5
        End If
        If RadioButton6.Checked = True Then
            w6.RB = 6
        End If
        z0.TP6 = w6
        '-----------------------------------------
        Dim fs As New FileStream(puth & "\Temp\Serializable.dat", FileMode.Create)
        Dim bf As New BinaryFormatter
        bf.Serialize(fs, z0)
        fs.Close()
    End Sub

    ''' <summary>
    ''' Действия при загрузке формы
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        ' определение наличия звуковой карты
        Dim i As Integer
        i = waveOutGetNumDevs()
        If i > 0 Then
            'MsgBox("Звуковая карта найдена! " & i)
        Else
            MsgBox("Звуковой карты нет!")
        End If

        'регистрация BassNet.dll
        BassNet.Registration("info@ledeffects.net", "2X2914241952318")
        'Инициализация BassNet.dll
        Bass.BASS_RecordInit(-1)
        recChannel = Bass.BASS_RecordStart(44100, 1, 0, Nothing, IntPtr.Zero)

        g = Me.CreateGraphics()
        g.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias

        'рассчитаем координаты светодиодов по X и Y
        Dim col, row
        For col = 0 To 7
            For row = 0 To 7
                st_led = (8 * row + col)
                x(st_led) = xc + (col * 15)
                y(st_led) = yc + (row * 15)
            Next
        Next

        Randomize()

        puth = Application.StartupPath
        'заполним комбобокс данными по городам из файла
        Dim fFile As Short
        Dim stroca As String = ""
        fFile = FreeFile()
        FileOpen(fFile, puth & "\GismeteoCodSity.txt", OpenMode.Input) 'открываем файл для чтения
        While Not EOF(1) 'пока не конец файла
            Input(fFile, stroca)
            ComboBox1.Items.Add(stroca)
        End While
        FileClose(fFile)

        'заполним комбобокс текстовыми файлами
        Dim D = IO.Directory.GetFiles(puth & "\Temp\", "*.txt")
        Dim MaxSprite = D.Length

        'Dim xxx As Integer = 0
        For Each F As String In D
            ComboBox3.Items.Add(System.IO.Path.GetFileNameWithoutExtension(F))
            'xxx = 1 + xxx
        Next

        'Вычитаем сериализацию
        Dim fs As New FileStream(puth & "\Temp\Serializable.dat", FileMode.Open)
        Dim bf As New BinaryFormatter
        Dim z0 As New MyClass0
        z0 = Convert.ChangeType(bf.Deserialize(fs), z0.GetType())
        '-----------------------------------------
        TrackBar1.Value = z0.TP1.TB1
        TrackBar2.Value = z0.TP1.TB2
        TrackBar6.Value = z0.TP1.TB6
        CheckBox2.Checked = z0.TP1.CB2
        CheckBox7.Checked = z0.TP1.CB7
        If z0.TP1.RB = 1 Then RadioButton1.Checked = True
        If z0.TP1.RB = 2 Then RadioButton2.Checked = True
        If z0.TP1.RB = 3 Then RadioButton3.Checked = True
        '-----------------------------------------
        TrackBar3.Value = z0.TP2.TB3
        CheckBox1.Checked = z0.TP2.CB1
        If z0.TP2.Clok = 1 Then Clock1.Checked = True
        If z0.TP2.Clok = 2 Then Clock2.Checked = True
        If z0.TP2.Clok = 3 Then Clock3.Checked = True
        '-----------------------------------------
        TrackBar8.Value = z0.TP3.TB8
        CheckBox9.Checked = z0.TP3.CB9
        CheckBox10.Checked = z0.TP3.CB10
        If z0.TP3.RB = 12 Then
            RadioButton12.Checked = True
        Else
            RadioButton11.Checked = True
        End If
        ComboBox2.SelectedIndex = z0.TP3.Combo2
        '-----------------------------------------
        TrackBar5.Value = z0.TP4.TB5
        CheckBox3.Checked = z0.TP4.CB3
        CheckBox6.Checked = z0.TP4.CB6
        If z0.TP4.RB = 7 Then
            RadioButton7.Checked = True
        Else
            RadioButton8.Checked = True
        End If
        ComboBox3.SelectedIndex = z0.TP4.Combo3
        '-----------------------------------------
        TrackBar7.Value = z0.TP5.TB7
        CheckBox4.Checked = z0.TP5.CB4
        CheckBox8.Checked = z0.TP5.CB8
        CheckBox11.Checked = z0.TP5.CB11
        CheckBox12.Checked = z0.TP5.CB12
        CheckBox13.Checked = z0.TP5.CB13
        CheckBox14.Checked = z0.TP5.CB14
        ComboBox1.SelectedIndex = z0.TP5.Combo1
        If z0.TP5.RB = 10 Then
            RadioButton10.Checked = True
        Else
            RadioButton9.Checked = True
        End If
        '-----------------------------------------
        TrackBar4.Value = z0.TP6.TB4
        CheckBox5.Checked = z0.TP6.CB5
        If z0.TP6.RB = 4 Then RadioButton4.Checked = True
        If z0.TP6.RB = 5 Then RadioButton5.Checked = True
        If z0.TP6.RB = 6 Then RadioButton6.Checked = True
        '-----------------------------------------
        flg_prognoz = True
        'Какая вкладка включена
        TabControl_index = z0.TabControl

        If z0.TabControl = 0 Then
            Timer1.Enabled = True
        Else
            'TabControl1.SelectedIndex = z0.TabControl
        End If

        fs.Close()

        'При открытии формы открыть девайс
        Handless = HID_OpenDevice(pid, vid, ver, ind)

    End Sub

    ''' <summary>
    ''' -= RANDOM =-
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        myPath.Reset()
        myPath1.Reset()
        'RND
        If RadioButton1.Checked = True Then
            Timer1.Interval = TrackBar2.Value * 10
            Dim col, row
            For col = 0 To 7
                For row = 0 To 7
                    st_led = (8 * col + row)
                    ellipseRect = New Rectangle(x(st_led), y(st_led), 13, 13)
                    random = Int(Rnd() * (20 - TrackBar1.Value))
                    If random = 0 Then
                        If CheckBox2.Checked = False Then
                            myPath1.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 0
                        Else
                            myPath.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 1
                        End If
                    Else
                        If CheckBox2.Checked = False Then
                            myPath.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 1
                        Else
                            myPath1.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 0
                        End If
                    End If
                Next
            Next
        End If

        'MATRIX
        If RadioButton2.Checked = True Then
            Timer1.Interval = TrackBar2.Value * 10
            Dim col, row
            For col = 7 To 1 Step -1
                For row = 0 To 7
                    st_led = (8 * col + row)
                    ellipseRect = New Rectangle(x(st_led), y(st_led), 13, 13)

                    If buf_USB(st_led - 8) = 1 Then
                        myPath.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 1
                    Else
                        myPath1.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 0
                    End If
                Next
            Next
            For row = 0 To 7
                st_led = row
                ellipseRect = New Rectangle(x(st_led), y(st_led), 13, 13)
                random = Int(Rnd() * (20 - TrackBar1.Value))
                If random = 1 Then
                    If CheckBox2.Checked = False Then
                        myPath1.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 0
                    Else
                        myPath.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 1
                    End If
                Else
                    If CheckBox2.Checked = False Then
                        myPath.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 1
                    Else
                        myPath1.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 0
                    End If
                End If
            Next

        End If

        'Kaleydoskop
        If RadioButton3.Checked = True Then

            'Уровень в каналах
            'Dim RetVal
            'RetVal = Bass.BASS_ChannelGetLevel(recChannel)
            '' Update ProgressBars
            'On Error Resume Next
            'pbLeft.Value = (Un4seen.Bass.Utils.HighWord(RetVal) / 500) 
            'pbRight.Value = (Un4seen.Bass.Utils.LowWord(RetVal) / 500)


            Dim flg_bass As Boolean
            If CheckBox7.Checked = True Then
                Timer1.Interval = 30
                Bass.BASS_ChannelGetData(recChannel, fft, BASSData.BASS_DATA_FFT4096)
                Dim Xxx As Integer
                zzz = 0
                For Xxx = 1 To 200
                    zzz += fft(Xxx)
                Next

                'Если уровень сигнала очень мал - то это шум! 
                If zzz >= 0.01 Then
                    'bass_detector
                    'следующий момент срабатывания зависит от уровня громкости и движка регулятора (zzz и TrackBar6)
                    If zzz_new > zzz Then
                        zzz_new = zzz_new - (0.1 * TrackBar6.Value * zzz)
                        Button5.BackColor = Color.Transparent
                        flg_bass = False
                    Else
                        zzz_new = zzz
                        Button5.BackColor = Color.Red
                        flg_bass = True
                    End If
                Else
                    flg_bass = True
                End If
            Else
                Timer1.Interval = TrackBar2.Value * 10
                flg_bass = True
            End If

            If flg_bass = True Then
                For i As Integer = 0 To 15
                    'Масса заполнения матрицы в зависимости от громкости (zzz)
                    If CheckBox7.Checked = True Then
                        Dim k = (zzz * 1.5) + 1
                        'If k < 1 Then k = 1
                        'If k > 18 Then k = 18
                        If zzz < 0.01 Then k = 0
                        random = Int(Rnd() * k) '(21 - TrackBar1.Value))
                    Else
                        random = Int(Rnd() * (21 - TrackBar1.Value))
                    End If


                    For j As Integer = 0 To 3
                        If random <= 1 Then
                            buf_USB(Kaleydos(4 * i + j)) = 1
                        Else
                            buf_USB(Kaleydos(4 * i + j)) = 0
                        End If

                    Next
                Next
                Dim col, row
                For col = 0 To 7
                    For row = 0 To 7
                        st_led = (8 * col + row)
                        ellipseRect = New Rectangle(x(st_led), y(st_led), 13, 13)
                        If buf_USB(st_led) = 1 Then
                            If CheckBox2.Checked = False Then
                                myPath1.AddEllipse(ellipseRect)
                                buf_USB(st_led) = 0
                            Else
                                myPath.AddEllipse(ellipseRect)
                                buf_USB(st_led) = 1
                            End If
                        Else
                            If CheckBox2.Checked = False Then
                                myPath.AddEllipse(ellipseRect)
                                buf_USB(st_led) = 1
                            Else
                                myPath1.AddEllipse(ellipseRect)
                                buf_USB(st_led) = 0
                            End If
                        End If
                    Next
                Next
                'flg_bass = False
            End If

        End If

        'g.SmoothingMode = Drawing2D.SmoothingMode.HighQuality
        g = Me.PictureBox1.CreateGraphics()
        g.FillPath(Brush, myPath)
        g.FillPath(Brush1, myPath1)

        Call USB()

    End Sub

    ''' <summary>
    ''' -= CLOCK =-
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        State = HID_DeviceTest(pid, vid, ver, ind)

        Label3.Text = TimeOfDay
        If Clock1.Checked = True Then
            Clock_to_massiv()

            steps = steps + 1
            If steps = 1 Then Clock_matrix(ed_chas)
            If steps = 2 Then qqq = Matrix_
            If steps = 3 Then Clock_matrix(des_chas)
            If steps = 4 Then qqq = Matrix_
            If steps = 5 Then qqq = Matrix_dvtch
            If steps = 6 Then qqq = Matrix_
            If steps = 7 Then Clock_matrix(ed_min)
            If steps = 8 Then qqq = Matrix_
            If steps = 9 Then Clock_matrix(des_min)
            If steps = 10 Then qqq = Matrix_
            If steps = 11 Then qqq = Matrix_dvtch
            If steps = 12 Then qqq = Matrix_
            If steps = 13 Then Clock_matrix(ed_sek)
            If steps = 14 Then qqq = Matrix_
            If steps = 15 Then Clock_matrix(des_sek)
            If steps = 16 Then qqq = Matrix_
            If steps = 17 Then qqq = Matrix_
            If steps = 18 Then qqq = Matrix_
            If steps = 19 Then qqq = Matrix_
            If steps = 20 Then qqq = Matrix_
            If steps = 21 Then qqq = Matrix_ : steps = 0


            myPath.Reset()
            myPath1.Reset()
            Dim col, row
            For row = 0 To 7
                For col = 0 To 7
                    st_led = (8 * row + col)
                    ellipseRect = New Rectangle(x(st_led), y(st_led), 13, 13)

                    If qqq(st_led) = 0 Then
                        If CheckBox1.Checked = False Then
                            myPath1.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 0
                        Else
                            myPath.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 1
                        End If
                    Else
                        If CheckBox1.Checked = False Then
                            myPath.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 1
                        Else
                            myPath1.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 0
                        End If
                    End If
                Next

            Next
        End If

        If Clock2.Checked = True Then

            If steps = 0 Then
                Clock_to_massiv()
                qqq = Matrix_
                qqq.CopyTo(www, 0)
                Clock_matrix(ed_chas)
                qqq.CopyTo(www, 64)
                For i = 128 To 135
                    www(i) = 0
                Next
                Clock_matrix(des_chas)
                qqq.CopyTo(www, 136)
                qqq = Matrix_dvtch
                qqq.CopyTo(www, 200)
                Clock_matrix(ed_min)
                qqq.CopyTo(www, 264)
                For i = 328 To 335
                    www(i) = 0
                Next
                Clock_matrix(des_min)
                qqq.CopyTo(www, 336)
                qqq = Matrix_dvtch
                qqq.CopyTo(www, 400)
                Clock_matrix(ed_sek)
                qqq.CopyTo(www, 464)
                For i = 528 To 535
                    www(i) = 0
                Next
                Clock_matrix(des_sek)
                qqq.CopyTo(www, 536)
                qqq = Matrix_
                qqq.CopyTo(www, 600)

            End If
            myPath.Reset()
            myPath1.Reset()
            Dim col, row
            For row = 0 To 7
                For col = 0 To 7
                    st_led = (8 * row) + col
                    ellipseRect = New Rectangle(x(st_led), y(st_led), 13, 13)

                    If www(st_led + (steps * 8)) = False Then
                        If CheckBox1.Checked = False Then
                            myPath1.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 0
                        Else
                            myPath.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 1
                        End If
                    Else
                        If CheckBox1.Checked = False Then
                            myPath.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 1
                        Else
                            myPath1.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 0
                        End If
                    End If
                Next
            Next

            steps = steps + 1
            If steps = 75 Then steps = 0
        End If

        If Clock3.Checked = True Then

            If steps = 0 Then
                Clock_to_massiv()
                qqq = Matrix_
                For i = 0 To 7
                    For j = 0 To 7
                        www((80 * i) + j) = qqq((8 * i) + j)
                    Next
                Next
                Clock_matrix(ed_chas)
                For i = 0 To 7
                    For j = 0 To 7
                        www((80 * i) + j + 8) = qqq((8 * i) + j)
                    Next
                Next
                Clock_matrix(des_chas)
                For i = 0 To 7
                    For j = 0 To 7
                        www((80 * i) + j + 16) = qqq((8 * i) + j)
                    Next
                Next
                qqq = Matrix_dvtch
                For i = 0 To 7
                    For j = 0 To 7
                        www((80 * i) + j + 24) = qqq((8 * i) + j)
                    Next
                Next
                Clock_matrix(ed_min)
                For i = 0 To 7
                    For j = 0 To 7
                        www((80 * i) + j + 32) = qqq((8 * i) + j)
                    Next
                Next
                Clock_matrix(des_min)
                For i = 0 To 7
                    For j = 0 To 7
                        www((80 * i) + j + 40) = qqq((8 * i) + j)
                    Next
                Next
                qqq = Matrix_dvtch
                For i = 0 To 7
                    For j = 0 To 7
                        www((80 * i) + j + 48) = qqq((8 * i) + j)
                    Next
                Next
                Clock_matrix(ed_sek)
                For i = 0 To 7
                    For j = 0 To 7
                        www((80 * i) + j + 56) = qqq((8 * i) + j)
                    Next
                Next
                Clock_matrix(des_sek)
                For i = 0 To 7
                    For j = 0 To 7
                        www((80 * i) + j + 64) = qqq((8 * i) + j)
                    Next
                Next
                qqq = Matrix_
                For i = 0 To 7
                    For j = 0 To 7
                        www((80 * i) + j + 72) = qqq((8 * i) + j)
                    Next
                Next
            End If

            myPath.Reset()
            myPath1.Reset()
            Dim col, row
            For row = 0 To 7
                For col = 0 To 7
                    st_led = (8 * row) + col
                    ellipseRect = New Rectangle(x(st_led), y(st_led), 13, 13)

                    If www((80 * row) + col + steps) = False Then
                        If CheckBox1.Checked = False Then
                            myPath1.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 0
                        Else
                            myPath.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 1
                        End If
                    Else
                        If CheckBox1.Checked = False Then
                            myPath.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 1
                        Else
                            myPath1.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 0
                        End If
                    End If
                Next
            Next
            steps = steps + 1
            If steps = 75 Then steps = 0
        End If
        'g.SmoothingMode = Drawing2D.SmoothingMode.HighQuality
        g = Me.PictureBox1.CreateGraphics()
        g.FillPath(Brush, myPath)
        g.FillPath(Brush1, myPath1)

        Call USB()
    End Sub

    Private Sub Clock_to_massiv()
        If TimeOfDay.Hour.ToString.Length = 2 Then
            ed_chas = Strings.Left(TimeOfDay.Hour, 1)
            des_chas = Strings.Right(TimeOfDay.Hour, 1)
        Else
            ed_chas = 100
            des_chas = TimeOfDay.Hour
        End If

        If TimeOfDay.Minute.ToString.Length = 2 Then
            ed_min = Strings.Left(TimeOfDay.Minute, 1)
            des_min = Strings.Right(TimeOfDay.Minute, 1)
        Else
            ed_min = 0
            des_min = TimeOfDay.Minute
        End If

        If TimeOfDay.Second.ToString.Length = 2 Then
            ed_sek = Strings.Left(TimeOfDay.Second, 1)
            des_sek = Strings.Right(TimeOfDay.Second, 1)
        Else
            ed_sek = 0
            des_sek = TimeOfDay.Second
        End If

    End Sub

    ''' <summary>
    ''' -= MANY =-
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Timer3_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer3.Tick
        myPath.Reset()
        myPath1.Reset()
        Dim col, row
        Dim BUKI_1 As String
        Dim BUKI_2 As String
        Dim i = string_steps \ 8

        'Все буквы в верхний регистр
        If CheckBox9.Checked = False Then
            BUKI_1 = string_text(i)
            BUKI_2 = string_text(i + 1)
        Else
            BUKI_1 = string_text(i).ToString.ToUpper
            BUKI_2 = string_text(i + 1).ToString.ToUpper
        End If

        Dim Asc_1 As Integer = Asc(BUKI_1)
        Dim Asc_2 As Integer = Asc(BUKI_2)

        Dim j As Integer = string_steps - (i * 8)
        Dim h, k, f As Integer

        If RadioButton12.Checked = True Then
            For k = 0 To 7
                f = k + j
                For h = 0 To 7
                    If f < 8 Then
                        ddd(8 * h + k) = Code_table.TS(Asc_1)(8 * h + f)
                    Else
                        ddd(8 * h + k) = Code_table.TS(Asc_2)(8 * h + (f - 8))
                    End If
                Next
            Next
        Else
            For h = 0 To 7
                f = h + j
                For k = 0 To 7
                    If f < 8 Then
                        ddd(8 * h + k) = Code_table.TS(Asc_1)(8 * f + k)
                    Else
                        ddd(8 * h + k) = Code_table.TS(Asc_2)(8 * (f - 8) + k)
                    End If
                Next
            Next
        End If


        For row = 0 To 7
            For col = 0 To 7
                st_led = (8 * row) + col
                ellipseRect = New Rectangle(x(st_led), y(st_led), 13, 13)

                If ddd(st_led) = False Then
                    If CheckBox10.Checked = False Then
                        myPath1.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 0
                    Else
                        myPath.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 1
                    End If
                Else
                    If CheckBox10.Checked = False Then
                        myPath.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 1
                    Else
                        myPath1.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 0
                    End If
                End If
            Next
        Next
        string_steps = string_steps + 1
        If string_steps = (string_len - 1) * 8 Then string_steps = 0

        'g.SmoothingMode = Drawing2D.SmoothingMode.HighQuality
        g = Me.PictureBox1.CreateGraphics()
        g.FillPath(Brush, myPath)
        g.FillPath(Brush1, myPath1)

        Call USB()
    End Sub

    ''' <summary>
    ''' -= TEXT =-
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Timer4_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer4.Tick

        myPath.Reset()
        myPath1.Reset()
        Dim col, row
        Dim BUKI_1 As String
        Dim BUKI_2 As String
        Dim i = string_steps \ 8

        'Все буквы в верхний регистр
        If CheckBox6.Checked = False Then
            BUKI_1 = string_text(i)
            BUKI_2 = string_text(i + 1)
        Else
            BUKI_1 = string_text(i).ToString.ToUpper
            BUKI_2 = string_text(i + 1).ToString.ToUpper
        End If

        Dim Asc_1 As Integer = Asc(BUKI_1)
        Dim Asc_2 As Integer = Asc(BUKI_2)

        Dim j As Integer = string_steps - (i * 8)
        Dim h, k, f As Integer

        If RadioButton7.Checked = True Then
            For k = 0 To 7
                f = k + j
                For h = 0 To 7
                    If f < 8 Then
                        ddd(8 * h + k) = Code_table.TS(Asc_1)(8 * h + f)
                    Else
                        ddd(8 * h + k) = Code_table.TS(Asc_2)(8 * h + (f - 8))
                    End If
                Next
            Next
        Else
            For h = 0 To 7
                f = h + j
                For k = 0 To 7
                    If f < 8 Then
                        ddd(8 * h + k) = Code_table.TS(Asc_1)(8 * f + k)
                    Else
                        ddd(8 * h + k) = Code_table.TS(Asc_2)(8 * (f - 8) + k)
                    End If
                Next
            Next
        End If


        For row = 0 To 7
            For col = 0 To 7
                st_led = (8 * row) + col
                ellipseRect = New Rectangle(x(st_led), y(st_led), 13, 13)

                If ddd(st_led) = False Then
                    If CheckBox3.Checked = False Then
                        myPath1.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 0
                    Else
                        myPath.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 1
                    End If
                Else
                    If CheckBox3.Checked = False Then
                        myPath.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 1
                    Else
                        myPath1.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 0
                    End If
                End If
            Next
        Next
        string_steps = string_steps + 1
        If string_steps = (string_len - 1) * 8 Then string_steps = 0

        'g.SmoothingMode = Drawing2D.SmoothingMode.HighQuality
        g = Me.PictureBox1.CreateGraphics()
        g.FillPath(Brush, myPath)
        g.FillPath(Brush1, myPath1)

        Call USB()
    End Sub

    ''' <summary>
    ''' -= POGODA =-
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Timer5_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer5.Tick

        myPath.Reset()
        myPath1.Reset()
        Dim col, row
        Dim BUKI_1 As String
        Dim BUKI_2 As String
        Dim i = string_steps \ 8

        'Все буквы в верхний регистр
        If CheckBox8.Checked = False Then
            BUKI_1 = string_text(i)
            BUKI_2 = string_text(i + 1)
        Else
            BUKI_1 = string_text(i).ToString.ToUpper
            BUKI_2 = string_text(i + 1).ToString.ToUpper
        End If

        Dim Asc_1 As Integer = Asc(BUKI_1)
        Dim Asc_2 As Integer = Asc(BUKI_2)

        Dim j As Integer = string_steps - (i * 8)
        Dim h, k, f As Integer

        If RadioButton10.Checked = True Then
            For k = 0 To 7
                f = k + j
                For h = 0 To 7
                    If f < 8 Then
                        ddd(8 * h + k) = Code_table.TS(Asc_1)(8 * h + f)
                    Else
                        ddd(8 * h + k) = Code_table.TS(Asc_2)(8 * h + (f - 8))
                    End If
                Next
            Next
        Else
            For h = 0 To 7
                f = h + j
                For k = 0 To 7
                    If f < 8 Then
                        ddd(8 * h + k) = Code_table.TS(Asc_1)(8 * f + k)
                    Else
                        ddd(8 * h + k) = Code_table.TS(Asc_2)(8 * (f - 8) + k)
                    End If
                Next
            Next
        End If


        For row = 0 To 7
            For col = 0 To 7
                st_led = (8 * row) + col
                ellipseRect = New Rectangle(x(st_led), y(st_led), 13, 13)

                If ddd(st_led) = False Then
                    If CheckBox4.Checked = False Then
                        myPath1.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 0
                    Else
                        myPath.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 1
                    End If
                Else
                    If CheckBox4.Checked = False Then
                        myPath.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 1
                    Else
                        myPath1.AddEllipse(ellipseRect)
                        buf_USB(st_led) = 0
                    End If
                End If
            Next
        Next
        string_steps = string_steps + 1
        If string_steps = (string_len - 1) * 8 Then string_steps = 0

        'g.SmoothingMode = Drawing2D.SmoothingMode.HighQuality
        g = Me.PictureBox1.CreateGraphics()
        g.FillPath(Brush, myPath)
        g.FillPath(Brush1, myPath1)

        Call USB()

    End Sub

    ''' <summary>
    ''' -= SPECTR =-
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Timer6_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer6.Tick
        Bass.BASS_ChannelGetData(recChannel, fft, BASSData.BASS_DATA_FFT4096)
        'BASS_RecordStart(11025,2,0,nil,0) где - 11025 это частота дискритизации сигнала. 2 - число каналов
        'BASS_ChannelGetData(channel1, @fftdata, BASS_DATA_FFT4096) где - BASS_DATA_FFT4096 - это константа, 
        'соответствующая частоте дискритизации 4096Гц и при заданном параметре функция возвращает 2048 значений (массив fft).
        'Каждую секунду можно получать данные амплитуд на определенных частотах. 
        'fftdata(i) эквивалентно значении амплитуды на частоте эквивалентной переменной i. 
        'Т.е. для каждой частоты своя амплитуда. 
        'Чтобы получить суммарную амплитуду, нужно просто просуммировать все значения массива по модулю. 
        'шаг одной выборки = 11025/2048 = 5,38 Гц
        '     for x= 1 to 300
        '       freq=freq+(fft(x))
        '     next
        ' freq=freq/300
        ' усреднённая частота в диапазоне 0-1600 Гц (300*5,38)
        'Средняя частота – 800 Гц

        'Суммируем значения выборок фурье для каждого из каналов определённой частоты 
        'Октавные фильтры            (10 шт): 31,5 - 63 - 125 - 250 - 512 - 1к - 2к - 4к - 8к - 16к
        'Третьоктавные               (31 шт): 20 - 25 - 31,5 - 40 - 50 - 63 - 80 - 100 - 126 - 160 - 200 - 250 - 320 - 400 - 500 - 640 - 800 - 1к ...
        Dim Xxx As Integer
        '75 Hz 
        Z(0) = 0
        For Xxx = 1 To 6
            Z(0) += fft(Xxx)
        Next

        '150 Hz 
        Z(1) = 0
        For Xxx = 7 To 15
            Z(1) += fft(Xxx)
        Next

        '312 Hz 
        Z(2) = 0
        For Xxx = 16 To 31
            Z(2) += fft(Xxx)
        Next

        '625 Hz 
        Z(3) = 0
        For Xxx = 32 To 63
            Z(3) += fft(Xxx)
        Next

        '1,25 kHz  
        Z(4) = 0
        For Xxx = 64 To 127
            Z(4) += fft(Xxx)
        Next

        '2,5 kHz 
        Z(5) = 0
        For Xxx = 128 To 255
            Z(5) += fft(Xxx)
        Next

        '5 kHz 
        Z(6) = 0
        For Xxx = 256 To 511
            Z(6) += fft(Xxx)
        Next

        '10 kHz 
        Z(7) = 0
        For Xxx = 512 To 1023
            Z(7) += fft(Xxx)
        Next


        zzz = 0
        For Xxx = 0 To 7
            zzz = zzz + Z(Xxx)
        Next





        'Если уровень сигнала очень мал - то это шум! 
        If zzz >= 0.01 Then
            'bass_detector
            Math.Sqrt(zzz)
            If zzz_new > zzz Then
                zzz_new = zzz_new - (0.02 * TrackBar6.Value)
                Button5.BackColor = Color.Transparent
            Else
                zzz_new = zzz
                Button5.BackColor = Color.Red
            End If

            'K = (master / zzz) * TrackBar1.Value * 15
            K = 10 * TrackBar4.Value
            For Xxx = 0 To 7
                'Чувствительность

                Z(Xxx) = Z(Xxx) * K '200 
                'Логарифмирование каждого канала 
                Yyy(Xxx) = Math.Sqrt(Z(Xxx))
                D(Xxx) = Convert.ToInt16(Z(Xxx))
                If D(Xxx) > 63 Then D(Xxx) = 63
                If D(Xxx) < 0 Then D(Xxx) = 0
                D(Xxx) = D(Xxx) \ 8
            Next
        Else
            Button5.BackColor = Color.Transparent
            For Xxx = 0 To 7
                D(Xxx) = 0
            Next
        End If

        If D(0) > D(1) Then
            D2(0) = D(0)
            D1(0) = (D(1) + D(0)) \ 2
        End If
        If D(0) < D(1) Then
            D1(0) = D(0)
            D2(0) = (D(1) + D(0)) \ 2
        End If
        If D(0) = D(1) Then
            D1(0) = D(0)
            D2(0) = D(0)
        End If

        For s = 1 To 7
            If D(s) > D(s - 1) Then
                D2(s) = D(s)
                D1(s) = D2(s - 1) + 1
            End If
            If D(s) < D(s - 1) Then
                D1(s) = D(s)
                D2(s) = D1(s - 1) - 1
            End If
            If D(s) = D(s - 1) Then
                D1(s) = D(s)
                D2(s) = D(s)
            End If
            If D2(s) < D1(s) Then
                Dim d3 = D2(s)
                D2(s) = D1(s)
                D1(s) = d3
            End If
        Next

        'Падающие пики
        ccc = ccc + 1
        For s = 0 To 7
            If D(s) > Dmax(s) Then
                Dmax(s) = D(s)
            Else
                If ccc = 5 Then

                    Dmax(s) = Dmax(s) - 1

                End If
            End If
        Next
        If ccc = 5 Then ccc = 0


        myPath.Reset()
        myPath1.Reset()
        Dim col, row
        For col = 7 To 0 Step -1
            For row = 0 To 7
                st_led = (8 * col + row)
                ellipseRect = New Rectangle(x(st_led), y(st_led), 13, 13)

                If RadioButton4.Checked = True Then
                    If D(row) >= (7 - col) Or Dmax(row) = (7 - col) Then
                        If CheckBox5.Checked = True Then
                            myPath1.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 0
                        Else
                            myPath.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 1
                        End If
                    Else
                        If CheckBox5.Checked = True Then
                            myPath.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 1
                        Else
                            myPath1.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 0
                        End If
                    End If
                End If

                If RadioButton5.Checked = True Then
                    If D(row) >= (7 - col) Then
                        If CheckBox5.Checked = True Then
                            myPath1.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 0
                        Else
                            myPath.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 1
                        End If
                    Else
                        If CheckBox5.Checked = True Then
                            myPath.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 1
                        Else
                            myPath1.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 0
                        End If
                    End If
                End If

                If RadioButton6.Checked = True Then
                    If (7 - col) >= D1(row) And (7 - col) <= D2(row) Then
                        If CheckBox5.Checked = True Then
                            myPath1.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 0
                        Else
                            myPath.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 1
                        End If
                    Else
                        If CheckBox5.Checked = True Then
                            myPath.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 1
                        Else
                            myPath1.AddEllipse(ellipseRect)
                            buf_USB(st_led) = 0
                        End If
                    End If
                End If


            Next
        Next

        g = Me.PictureBox1.CreateGraphics()
        g.FillPath(Brush, myPath)
        g.FillPath(Brush1, myPath1)

        Call USB()

    End Sub

    ''' <summary>
    ''' -= MENEDGER =-
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Timer7_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer7.Tick

    End Sub

    ''' <summary>
    ''' Очистить матрицу
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub reset_matrix()
        myPath1.Reset()
        Dim col, row
        For col = 0 To 7
            For row = 0 To 7
                st_led = (8 * col + row)
                ellipseRect = New Rectangle(x(st_led), y(st_led), 13, 13)
                myPath1.AddEllipse(ellipseRect)
                buf_USB(st_led) = 0
            Next
        Next
        g = Me.PictureBox1.CreateGraphics()
        g.FillPath(Brush1, myPath1)
        Call USB()
    End Sub

    ''' <summary>
    ''' Записываем необходимый массив в дополнительную переменную
    ''' </summary>
    ''' <param name="qwerty"></param>
    ''' <remarks></remarks>
    Private Sub Clock_matrix(ByVal qwerty)
        If qwerty = 0 Then qqq = Matrix_0
        If qwerty = 1 Then qqq = Matrix_1
        If qwerty = 2 Then qqq = Matrix_2
        If qwerty = 3 Then qqq = Matrix_3
        If qwerty = 4 Then qqq = Matrix_4
        If qwerty = 5 Then qqq = Matrix_5
        If qwerty = 6 Then qqq = Matrix_6
        If qwerty = 7 Then qqq = Matrix_7
        If qwerty = 8 Then qqq = Matrix_8
        If qwerty = 9 Then qqq = Matrix_9
        If qwerty = 100 Then qqq = Matrix_
    End Sub

    Private Sub Clock1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Clock1.CheckedChanged
        steps = 0
    End Sub

    Private Sub Clock2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Clock2.CheckedChanged
        steps = 0
    End Sub

    ''' <summary>
    ''' Передача данных в HID - устройство
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub USB()
        State = HID_DeviceTest(pid, vid, ver, ind)

        If State = 0 Then 'если устройство отключено
            HIDconnect.Text = "Девайс отключен"
            'res = HID_CloseDevice(Handle)
            'Handless = HID_OpenDevice(pid, vid, ver, ind)
        Else    'если устройство подключено, то передаём данные 
            HIDconnect.Text = "Девайс подключен"

            Handless = HID_OpenDevice(pid, vid, ver, ind)

            Buffers(1) = (buf_USB(56) * 128) + (buf_USB(57) * 64) + (buf_USB(58) * 32) + (buf_USB(59) * 16) + (buf_USB(60) * 8) + (buf_USB(61) * 4) + (buf_USB(62) * 2) + (buf_USB(63) * 1)
            res = HID_WriteDevice(Handless, Buffers, 2)

            Buffers(1) = (buf_USB(48) * 128) + (buf_USB(49) * 64) + (buf_USB(50) * 32) + (buf_USB(51) * 16) + (buf_USB(52) * 8) + (buf_USB(53) * 4) + (buf_USB(54) * 2) + (buf_USB(55) * 1)
            res = HID_WriteDevice(Handless, Buffers, 2)

            Buffers(1) = (buf_USB(40) * 128) + (buf_USB(41) * 64) + (buf_USB(42) * 32) + (buf_USB(43) * 16) + (buf_USB(44) * 8) + (buf_USB(45) * 4) + (buf_USB(46) * 2) + (buf_USB(47) * 1)
            res = HID_WriteDevice(Handless, Buffers, 2)

            Buffers(1) = (buf_USB(32) * 128) + (buf_USB(33) * 64) + (buf_USB(34) * 32) + (buf_USB(35) * 16) + (buf_USB(36) * 8) + (buf_USB(37) * 4) + (buf_USB(38) * 2) + (buf_USB(39) * 1)
            res = HID_WriteDevice(Handless, Buffers, 2)

            Buffers(1) = (buf_USB(24) * 128) + (buf_USB(25) * 64) + (buf_USB(26) * 32) + (buf_USB(27) * 16) + (buf_USB(28) * 8) + (buf_USB(29) * 4) + (buf_USB(30) * 2) + (buf_USB(31) * 1)
            res = HID_WriteDevice(Handless, Buffers, 2)

            Buffers(1) = (buf_USB(16) * 128) + (buf_USB(17) * 64) + (buf_USB(18) * 32) + (buf_USB(19) * 16) + (buf_USB(20) * 8) + (buf_USB(21) * 4) + (buf_USB(22) * 2) + (buf_USB(23) * 1)
            res = HID_WriteDevice(Handless, Buffers, 2)

            Buffers(1) = (buf_USB(8) * 128) + (buf_USB(9) * 64) + (buf_USB(10) * 32) + (buf_USB(11) * 16) + (buf_USB(12) * 8) + (buf_USB(13) * 4) + (buf_USB(14) * 2) + (buf_USB(15) * 1)
            res = HID_WriteDevice(Handless, Buffers, 2)

            Buffers(1) = (buf_USB(0) * 128) + (buf_USB(1) * 64) + (buf_USB(2) * 32) + (buf_USB(3) * 16) + (buf_USB(4) * 8) + (buf_USB(5) * 4) + (buf_USB(6) * 2) + (buf_USB(7) * 1)
            res = HID_WriteDevice(Handless, Buffers, 2)

            res = HID_CloseDevice(Handless)

        End If

    End Sub

    ''' <summary>
    ''' Загрузить текстовый файл
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        'LOAD FILE
        OpenFileDialog1.InitialDirectory = Application.StartupPath
        'OpenFileDialog1.DefaultExt = "txt"
        OpenFileDialog1.Filter = "Файлы текста (*.txt)|*.txt"
        OpenFileDialog1.FileName = ""
        Dim Text_string As String = ""
        If OpenFileDialog1.ShowDialog = DialogResult.OK Then

            FileOpen(1, OpenFileDialog1.FileName, OpenMode.Input)

            Do Until EOF(1)             'читаем строки из файла
                Text_string = Text_string + LineInput(1)
            Loop
            FileClose()
            TextBox1.Text = Text_string
            string_len = TextBox1.Text.Length
            string_text = TextBox1.Text
            string_steps = 0
        End If
    End Sub

    ''' <summary>
    ''' При смене города - получить новый прогноз
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        If flg_prognoz = True Then
            TextBox2.Text = "Подождите. Идёт загрузка информации!"
            reset_matrix()
            sity = ComboBox1.Text 'Strings.Left(ComboBox1.Text, 5)
            Dim str As String = MyClass_prognoz.Get_prognoz(sity, CheckBox11.Checked, CheckBox12.Checked, CheckBox13.Checked, CheckBox14.Checked)
            string_len = str.Length
            TextBox2.Text = str
            string_text = str
            string_steps = 0
        End If
    End Sub

    ''' <summary>
    ''' скорость отображения часов
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TrackBar3_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar3.ValueChanged
        Timer2.Interval = TrackBar3.Value
    End Sub

    ''' <summary>
    ''' Скорость бегущей строки
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TrackBar5_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar5.ValueChanged
        Timer4.Interval = TrackBar5.Value
    End Sub

    ''' <summary>
    ''' скорость прогноза погоды
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TrackBar7_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar7.ValueChanged
        Timer5.Interval = TrackBar7.Value
    End Sub

    ''' <summary>
    ''' Скорость курса валют
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TrackBar8_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar8.ValueChanged
        Timer3.Interval = TrackBar8.Value
    End Sub

    ''' <summary>
    ''' Скорость RANDOM
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TrackBar2_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TrackBar2.ValueChanged
        Timer1.Interval = TrackBar2.Value * 10
    End Sub

    ''' <summary>
    ''' Выбор режима работы
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TabControl1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TabControl1.SelectedIndexChanged
        If TabControl1.SelectedTab.Name = "TabPage1" Then
            reset_matrix()
            Timer1.Enabled = True
            Timer2.Enabled = False
            Timer3.Enabled = False
            Timer4.Enabled = False
            Timer5.Enabled = False
            Timer6.Enabled = False
            Timer7.Enabled = False
        End If
        If TabControl1.SelectedTab.Name = "TabPage2" Then
            reset_matrix()
            Timer1.Enabled = False
            Timer2.Enabled = True
            Timer3.Enabled = False
            Timer4.Enabled = False
            Timer5.Enabled = False
            Timer6.Enabled = False
            Timer7.Enabled = False
        End If
        If TabControl1.SelectedTab.Name = "TabPage3" Then
            reset_matrix()

            If ComboBox2.Text = "Ukraine" Then
                Dim str As String = MyClass_manyUK.Get_many()
                string_len = str.Length
                TextBox3.Text = str
                string_text = str
            Else
                Dim str As String = MyClass_manyRU.Get_many()
                string_len = str.Length
                TextBox3.Text = str
                string_text = str
            End If

            string_steps = 0
            Timer1.Enabled = False
            Timer2.Enabled = False
            Timer3.Enabled = True
            Timer4.Enabled = False
            Timer5.Enabled = False
            Timer6.Enabled = False
            Timer7.Enabled = False
        End If
        If TabControl1.SelectedTab.Name = "TabPage4" Then
            reset_matrix()
            'Загрузить текстовый файл
            Try
                Dim Text_string As String = ""
                Text_file = puth & "\Temp\" & ComboBox3.Text & ".txt"
                FileOpen(1, Text_file, OpenMode.Input)
                Do Until EOF(1)             'читаем строки из файла
                    Text_string = Text_string + LineInput(1)
                Loop
                FileClose()
                TextBox1.Text = Text_string
                string_len = TextBox1.Text.Length
                string_text = TextBox1.Text
                string_steps = 0
            Catch ex As Exception
                TextBox1.Text = "А текста то нету!!! "
            End Try
            string_len = TextBox1.Text.Length
            string_text = TextBox1.Text
            string_steps = 0
            Timer1.Enabled = False
            Timer2.Enabled = False
            Timer3.Enabled = False
            Timer4.Enabled = True
            Timer5.Enabled = False
            Timer6.Enabled = False
            Timer7.Enabled = False
        End If
        If TabControl1.SelectedTab.Name = "TabPage5" Then
            reset_matrix()
            sity = ComboBox1.Text 'Strings.Left(ComboBox1.Text, 5)
            Dim str As String = MyClass_prognoz.Get_prognoz(sity, CheckBox11.Checked, CheckBox12.Checked, CheckBox13.Checked, CheckBox14.Checked)

            string_len = str.Length
            TextBox2.Text = str
            string_text = str
            string_steps = 0

            Timer1.Enabled = False
            Timer2.Enabled = False
            Timer3.Enabled = False
            Timer4.Enabled = False
            Timer5.Enabled = True
            Timer6.Enabled = False
            Timer7.Enabled = False
        End If
        If TabControl1.SelectedTab.Name = "TabPage6" Then
            reset_matrix()
            Timer1.Enabled = False
            Timer2.Enabled = False
            Timer3.Enabled = False
            Timer4.Enabled = False
            Timer5.Enabled = False
            Timer6.Enabled = True
            Timer7.Enabled = False
        End If
        If TabControl1.SelectedTab.Name = "TabPage7" Then
            reset_matrix()
            Timer1.Enabled = False
            Timer2.Enabled = False
            Timer3.Enabled = False
            Timer4.Enabled = False
            Timer5.Enabled = False
            Timer6.Enabled = False
            Timer7.Enabled = True
        End If
    End Sub

    ''' <summary>
    ''' Действие при сворачивании формы
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form_gadjet_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        On Error Resume Next
        Me.Show()
        If Form.ActiveForm.WindowState = FormWindowState.Minimized Then
            NotifyIcon1.Visible = True
            Me.Hide()
        End If
    End Sub

    ''' <summary>
    ''' Действие при клике по иконке в трее
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub NotifyIcon1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles NotifyIcon1.Click
        Me.Show()
        WindowState = FormWindowState.Normal
        NotifyIcon1.Visible = False
    End Sub

    ''' <summary>
    ''' Загрузить новый текст
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ComboBox3_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox3.SelectedIndexChanged
        Dim Text_string As String = ""
        Text_file = puth & "\Temp\" & ComboBox3.Text & ".txt"
        FileOpen(1, Text_file, OpenMode.Input)
        Do Until EOF(1)             'читаем строки из файла
            Text_string = Text_string + LineInput(1)
        Loop
        FileClose()
        TextBox1.Text = Text_string
        string_len = TextBox1.Text.Length
        string_text = TextBox1.Text
        string_steps = 0
    End Sub

    ''' <summary>
    ''' Курсы валют Украины - России
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ComboBox2_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox2.SelectedIndexChanged
        If flg_prognoz = True Then
            reset_matrix()
            Many_file = puth & "\Temp\many" & ".html"
            Dim datas = Microsoft.VisualBasic.Left(Date.Today.ToString, 10)

            If ComboBox2.Text = "Ukraine" Then
                Dim str As String = MyClass_manyUK.Get_many()
                string_len = str.Length
                TextBox3.Text = str
                string_text = str
            Else
                Dim str As String = MyClass_manyRU.Get_many()
                string_len = str.Length
                TextBox3.Text = str
                string_text = str
            End If

            string_steps = 0
        End If
    End Sub

    ''' <summary>
    ''' О программе
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ToolStripMenuItem5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem5.Click
        AboutBox.ShowDialog()
    End Sub

    ''' <summary>
    ''' Добавить приложение в автозагрузку
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ToolStripMenuItem3_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem3.Click
        Dim regname As String = My.Application.Info.AssemblyName 'Название приложения 
        Dim filepath As String = System.Reflection.Assembly.GetExecutingAssembly().Location 'Путь к исполняемому файлу
        Dim Start As Microsoft.Win32.RegistryKey = My.Computer.Registry.CurrentUser.OpenSubKey("SOFTWARE\Microsoft\Windows\CurrentVersion\Run", True)
        Start.SetValue(regname, Application.ExecutablePath) 'Создаем ключ и пишем в него значение - полный путь к исполняемому файлу, пусть даже если он был переименован
    End Sub

    ''' <summary>
    ''' Удалить приложение из автозагрузки
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ToolStripMenuItem4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem4.Click
        Dim regname As String = My.Application.Info.AssemblyName 'Название приложения 
        Dim Start As Microsoft.Win32.RegistryKey = My.Computer.Registry.CurrentUser.OpenSubKey("SOFTWARE\Microsoft\Windows\CurrentVersion\Run", True)
        Start.DeleteValue(regname) 'Удаляем ключ с записью об автозапуске, неважно, был ли переименован файл
    End Sub

End Class
